

-- hook PlayerName autocomplete to add alts to mail list
-- store alts in DB, make sure its a per alliance list.
-- PlayerNameAutocomplete


BetterOutbox = LibStub("AceAddon-3.0"):NewAddon("BetterOutbox")

local db
local defaults = {
	profile = {
		alts = {}
	}
}
local alts
local realmName = GetRealmName()
local playerName = UnitName("player")
local englishFaction, localizedFaction = UnitFactionGroup("player")

local function NameCompletion( f, t )
	local text = f:GetText()
	local textlen = strlen(text)
	
	local num, name
	
	-- First check registered alts
	for name, v in pairs( alts ) do
		if name and text and strfind(strupper(name), strupper(text), 1, 1) == 1 then
			f:SetText(name)
			if f:IsInIMECompositionMode() then
				f:HighlightText(textlen - strlen(t), -1)
			else
				f:HighlightText(textlen, -1)
			end
			return		
		end
	end
	
	-- Check Friends
	num = GetNumFriends()
	if numFriends > 0 then
		for i=1, num do
			name = GetFriendInfo(i)
			if name and text and strfind(strupper(name), strupper(text), 1, 1) == 1  then
				f:SetText(name)
				if f:IsInIMECompositionMode() then
					f:HighlightText(textlen - strlen(t), -1)
				else
					f:HighlightText(textlen, -1)
				end
				return
			end
		end
	end	
	-- Check Guild
	num = GetNumGuildMembers(true)	-- true to include offline members
	if num > 0 then
		for i=1, num do
			name = GetGuildRosterInfo(i)
			if name and text and strfind(strupper(name), strupper(text), 1, 1) == 1 then
				f:SetText(name)
				if f:IsInIMECompositionMode() then
					f:HighlightText(textlen - strlen(t), -1)
				else
					f:HighlightText(textlen, -1)
				end
				return
			end
		end
	end	
end


function BetterOutbox:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("BetterOutboxDB", defaults, "Default")
	db = self.db.profile
	-- register this char as an alt
	if not db.alts[realmName.."::"..englishFaction] then
		db.alts[realmName.."::"..englishFaction] = {}
	end
	alts = db.alts[realmName.."::"..englishFaction]
	alts[playerName] = true
	
end

function BetterOutbox:OnEnable()
	self.oldOnChar = SendMailNameEditBox:GetScript("onChar")
	self.oldOnCharComposition = SendMailNameEditBox:GetScript("onCharComposition")
	
	SendMailNameEditBox:SetScript( "onChar", function(f, ...) NameCompletion(f) end)
	SendMailNameEditBox:SetScript( "onCharComposition", function(f, ...) if not f:IsInIMECompositionMode() then NameCompletion(f) end end )
end

function BetterOutbox:OnDisable()
	SendMailNameEditBox:SetScript("onChar", self.oldOnChar)
	SendMailNameEditBox:SetScript("onCharComposition", self.oldOnCharComposition)
end


